mod Ex07

incl Mtex

incl Mtexgr

incl Maux

incl Mterm

incl Mrd

loc rem 
  7. CVICENIE Z PREDMETU TEORIA VYPOCITATELNOSTI PRE PROGRAMATOROV

rem 
  VASE MENO: ?
  SKUPINA: ?
  VERZIA CL: 5.81.16
  DATUM: stvrtok 3.11.2005
  ******************************************************************************
  PMAIL: comp@nw.fmph.uniba.sk
  WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/comp
  ******************************************************************************
  SKUSKA (toto je len zakladny ramec, viz. tiez 1. prednaska):
  ULOHY: 20%
  MIDTERM: 20%
  FINALTERM: 60%
  ******************************************************************************
  POCET BODOV ZA ULOHY V TOMTO SUBORE: 3
  POCET BODOV ZA PREMIOVE ULOHY V TOMTO SUBORE: -
  ******************************************************************************
  PRENOS: <cl>/4i/prenos/ex/ex07/<vase meno>/ex07.cl
          kde <cl> je adresar /data/VYUKA/INF/CL na barbie.nw.fmph.uniba.sk
          ************************************************
          *** odovzdat do 8.11.2005 (utorok) do 18:00 ***
          ************************************************
  ******************************************************************************

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane rekurzivnym 
  indexom. Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subory \it  mtex*.cl  \end obsahuju makra pre CL-TeX. 
   \item \para Subor \it  maux.cl  \end obsahuju definicie niektorych funkcii a 
         predikatov. 
   \item \para Subor \it  mterm.cl  \end obsahuje aritmetizaciu rekurzivnych 
         termov. 
   \item \para Subor \it  mrd.cl  \end obsahuje aritmetizaciu vypoctoveho 
         modelu. 
   \item \para Subor \it  ex07.cl  \end obsahuje ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

fun/0 Foo 'Tex_f0_foo'
  Foo = 0

pred/0 Poo 'Tex_p0_poo'
  Poo <-> \f

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Lecture Notes in Theory 
         of Computability. 2001. 
   \item \para \it  [2]  \end P. J. Voda. Theory of Recursive Functions & 
         Computability. 2000. 
   \item \para \it  [3]  \end I. Korec. Uvod do teorie algoritmov. MFF UK. 
         Bratislava. 1983. 
  \end

rem 
  \para \bf  [CL] Syntax.  \end \header* pred/2 Q  \end Examples: 
  \def 
    pred R 
    R(x) <-> \eb y y <= x: Q(x,y)
  \end
  \def 
    pred R 
    R(x) <-> \eb y y < x: Q(x,y)
  \end
  \def 
    pred R 
    R(x) <-> 
      \ab y y <= x: Q(x,y)
  \end
  \def 
    pred R 
    R(x) <-> 
      \ab y y < x: Q(x,y)
  \end

rem 
  \para \bf  Chapter. Primitive Recursive Functions.  \end 

rem 
  \para \bf  Section. Course of Values Recursion with Measure.  \end 

rem 
  \para \bf  Subsection. Course of Values Recursion with Measure.  \end 

rem 
  \para \bf  Auxiliary functions and predicates.  \end See also the files \it  
  ex07.ps  \end and \it  ex07.pdf  \end. 

rem 
  \para \it  Arity function.  \end 

fun Ar 
  Ar(e) = Foo

rem 
  \para \it  Iterated contraction function.  \end 

fun/3 Cntri 'Tex_f3_gr_cntri'
  Cntri(t,n,rs) = Foo

rem 
  \para \it  Application function.  \end 

fun/2 At 'Tex_f2_gr_at'
  At(e,ts) = Foo

rem 
  \para \bf  Chapter. Recursive Functions.  \end 

rem 
  \para \bf  Section. Recursive Functions.  \end 

rem 
  \para \bf  Well-formed recursive indices.  \end See also the module 
  \ft Mterm \end. 

rem 
  \para \bf  Indices of identity functions.  \end 

fun/2 Xi 'Tex_f2_gr_xi'
  Xi(n,i) = Foo

rem 
  \para \bf  Indices of constant functions.  \end 

fun/2 Xc 'Tex_f2_gr_xc'
  Xc(n,m) = Foo

rem 
  \para \bf  Indices of nowhere defined partial functions.  \end 

fun Xundef 'Tex_f1_gr_xundef'
  Xundef(n) = Foo

rem 
  \para \bf  Turning recursive indices into well-formed ones.  \end 

fun/2 Xwf 'Tex_f2_gr_xwf'
  Xwf(n,e) = Foo

rem 
  \para \bf  Unary composition.  \end 

fun/2 Xcompu 'Tex_f2_gr_xcompu'
  Xcompu(e1,e2) = Foo

rem 
  \para \bf  Composition.  \end 

fun/3 Xcomp_1_2 'Tex_f3_gr_xcomp_1_2'
  Xcomp_1_2(e,e1,e2) = Foo

rem 
  \para \bf  Parametric function.  \end \it  [Uloha (1 bod)]  \end 

fun/2 Xparam 'Tex_f2_gr_xparam'
  Xparam(e,x) = Foo

rem 
  \para \bf  S-m-n theorem (Kleene).  \end 

fun/3 Xsmn_2_3 'Tex_f3_gr_xsmn_2_3'
  Xsmn_2_3(e,x1,x2) = Foo

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc fun/3 Eval1 
  Eval1(k,e,x1) = Ird(k,Apt(e,Cnm(x1),0))

loc fun/4 Eval2 
  Eval2(k,e,x1,x2) = Ird(k,Apt(e,Cnm(x1),Cnm(x2),0))

loc fun/5 Eval3 
  Eval3(k,e,x1,x2,x3) = Ird(k,Apt(e,Cnm(x1),Cnm(x2),Cnm(x3),0))

loc fun Test_fun 
  Test_fun(x) = Foo

loc fun/2 Itfa 
  Itfa(0,a) = a
  Itfa(n+1,a) = Itfa(n,(n,Test_fun(n)),a)

loc fun Itf 
  Itf(n) = Itfa(n,0)

loc pred Test_pred 
  Test_pred(x) <-> Poo

loc fun/2 Itpa 
  Itpa(0,a) = a
  Itpa(n+1,a) = Itpa(n,n,a) <- Test_pred(n)
  Itpa(n+1,a) = Itpa(n,a) <- ~Test_pred(n)

loc fun Itp 
  Itp(n) = Itpa(n,0)

